%define         _disable_ld_no_undefined 1

%define         major       3
%define         libname     %mklibname %{name} %{major}
%define         develname   %mklibname %{name} -d

Summary:        Fast Fourier transform library
Name:           fftw
Version:        3.3
Release:        %mkrel 1
License:        GPLv2+
Group:          System/Libraries

URL:            http://www.fftw.org
Source:         ftp://ftp.fftw.org/pub/fftw/%{name}-%{version}.tar.gz

BuildRequires:  gcc-gfortran
BuildRequires:  quadmath-devel
BuildRequires:  libgomp-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
FFTW is a collection of fast C routines for computing the Discrete
Fourier Transform in one or more dimensions. It includes complex,
real, and parallel transforms, can handle arbitrary array sizes
efficiently and can be called from Fortran.



%package wisdom
Summary:        FFTW-wisdom file generator
Group:          Development/Other

%description wisdom
This package contains a wisdom file generator to be used with the FFTW
Fourier transform library. These files contain saved information about how
to optimally compute transforms of various sizes.



%package -n %{libname}
Summary:        Fast Fourier transform library
Group:          System/Libraries
Provides:       %{name} = %{version}-%{release}
Obsoletes:      %{name} < 3.1.3

%description -n %{libname}
FFTW is a collection of fast C routines for computing the Discrete Fourier
Transform in one or more dimensions.  It includes complex, real, and
parallel transforms, and can handle arbitrary array sizes efficiently.



%package -n %{develname}
Summary:        Headers, libraries, & docs for FFTW fast Fourier transform library
Group:          Development/C
Requires:       %{libname} = %{version}-%{release}
Provides:       lib%{name}-devel = %{version}-%{release}
Provides:       %{name}%{major}-devel = %{version}-%{release}
Obsoletes:      %{libname}-devel < 3.1.3
Provides:       %{name}-devel = %{version}-%{release}

%description -n %{develname}
This package contains the additional header files, documentation, and
libraries you need to develop programs using the FFTW fast Fourier
transform library.



%prep
%setup -q

%build
export F77="gfortran"
mkdir build-std
pushd build-std
CONFIGURE_TOP=.. %configure2_5x \
                    --enable-shared \
                    --enable-threads \
                    --enable-openmp \
                    --enable-fortran \
                    %ifarch x86_64
                    --enable-sse2 \
                    %endif
                    --infodir=%{_infodir}

%make
popd

mkdir build-float
pushd build-float
CONFIGURE_TOP=.. %configure2_5x \
                    --enable-float \
                    --enable-shared \
                    --enable-threads \
                    --enable-openmp \
                    --enable-fortran \
                    %ifarch x86_64
                    --enable-sse2 \
                    %endif
                    --infodir=%{_infodir}
%make
popd

#SSE2 does not work with long-double
mkdir build-long-double
pushd build-long-double
CONFIGURE_TOP=.. %configure2_5x \
                    --enable-long-double \
                    --enable-shared \
                    --enable-threads \
                    --enable-openmp \
                    --enable-fortran \
                    --infodir=%{_infodir}
%make
popd

#SSE2 does not work with quad-precision
mkdir build-quad-precision
pushd build-quad-precision
CONFIGURE_TOP=.. %configure2_5x \
                    --enable-quad-precision \
                    --enable-shared \
                    --enable-threads \
                    --enable-openmp \
                    --enable-fortran \
                    --infodir=%{_infodir}



%check
make check -C build-std
make check -C build-float
make check -C build-long-double
make check -C build-quad-precision


%install
rm -fr %{buildroot}
pushd build-std
%makeinstall_std
popd
pushd build-float
%makeinstall_std
popd
pushd build-long-double
%makeinstall_std
popd
pushd build-quad-precision
%makeinstall_std
popd


rm -fr %{buildroot}/%{_docdir}/Make*
find %{buildroot}%{_libdir} -name *.la -delete


%clean
rm -rf %{buildroot}



%post -n %{develname}
%__install_info -e '* FFTW: (fftw%{major}).                     Fast Fourier Transform library.'\
                -s Libraries %{_infodir}/fftw%{major}.info%{_extension} %{_infodir}/dir


%preun -n %{develname}
%__install_info -e '* FFTW: (fftw%{major}).                     Fast Fourier Transform library.'\
                -s Libraries %{_infodir}/fftw%{major}.info%{_extension} %{_infodir}/dir --remove


%files -n %{name}-wisdom
%defattr (-,root,root)
%{_bindir}/fftw*-wisdom
%{_bindir}/fftw-wisdom-to-conf
%{_includedir}/fftw3.f*
%{_mandir}/man1/fftw-wisdom-to-conf.*
%{_mandir}/man1/fftw*-wisdom.*


%files -n %{libname}
%defattr (-,root,root)
%doc AUTHORS CO* NEWS README TODO 
%{_libdir}/libfftw*.so.%{major}*


%files -n %{develname}
%defattr (-,root,root)
%{_includedir}/*fftw*.h
%{_infodir}/fftw%{major}.info*
%doc doc/*
%{_libdir}/pkgconfig/*.pc
%{_libdir}/libfftw*.a
%{_libdir}/libfftw*.so


%changelog

* Fri Dec 09 2011 eatdirt <eatdirt> 3.3-1.mga2
+ Revision: 179767
- Upgrade to 3.3
- delete .la files
- added enable SSE2, openmp and quadruple precision

* Thu Jan 13 2011 ahmad <ahmad> 3.2.2-4.mga1
+ Revision: 8894
- drop old/unneeded scriptlets
- imported package fftw

